Subject: RFC 4388

From: Alfred Hönes <[email-masked]>
Date: Thu, 2 Mar 2006 13:26:10 +0100 (MEZ)

Hello,
I'd like to submit a few comments on the recently published RFC 4388
 authored by you.

(1)  [word omission]

The second paragraph of section 4.2 of RFC 4388 says:

   The DHCP Server MIB effort [DHCPMIB] grew out of traffic engineering
   and troubleshooting activities at large DHCP installations, and is
   primarily intended as a method of gathering performance statistics
   about servers the load presented to them.

It should perhaps better say:

   The DHCP Server MIB effort [DHCPMIB] grew out of traffic engineering
   and troubleshooting activities at large DHCP installations, and is
   primarily intended as a method of gathering performance statistics
|  about servers and the load presented to them.
                ^^^^^

(2)  [improper wording]

RFC 4388 repeatedly talks about

   "[an] IP address most recently accessed by a client"
                                  ^^^^^^^^^^^
where, IMHO, it should talk about

|  "[an] IP address most recently assigned to a client"
                                  ^^^^^^^^^^^
Rationale:
  The client may access any IP address at any time.  Such access
  is mostly unrelated to the protocol described in RFC 4338.

The affected places in the text I found are:
- Section 5, first paragraph of both the second and the third
  bulleted items, on page 10 / 11, respectively;
- Last paragraph on page 17 (within section 6.4.1).

(3)  [incomplete specification]

The second paragraph of Section 6.4.1, on page 17, says:

   In the event that an IP address appears in the "ciaddr" field of a
   DHCPLEASEQUERY message, if that IP address is one managed by the DHCP
   server, then that IP address MUST be set in the "ciaddr" field of a
   DHCPLEASEUNASSIGNED message.

It should in fact say:

   In the event that an IP address appears in the "ciaddr" field of a
   DHCPLEASEQUERY message, if that IP address is one managed by the DHCP
   server, then that IP address MUST be set in the "ciaddr" field of a
|  DHCPRELEASEACTIVE or DHCPLEASEUNASSIGNED message returned.
   ^^^^^^^^^^^^^^^^^^^^^                           ^^^^^^^^^

Rationale:
  From the remaining text, it can be inferred that the "ciaddr"
  field from the DHCPLEASEQUERY message should be copied to an
  DHCPRELEASEACTIVE reply message as well -- cf. section 6.4.2.

IMHO, this copy should be performed generally, i.e. also in the case
described by the subsequent paragraph:

   If the IP address is not managed by the DHCP server, then a
   DHCPLEASEUNKNOWN message must be returned.

that therefore might be amended to say:

   If the IP address is not managed by the DHCP server, then a
|  DHCPLEASEUNKNOWN message MUST be returned, with that IP address
|  set in the "ciaddr" field.

[The original 'must' should be a 'MUST' because the alternatives
are also specified as a 'MUST' -- or else the specification would
be incomplete.]

Taken together, it might be preferable to restate this fact by
only changing the first paragraph cited above as follows, and leave
the second paragraph unchanged with the exception of the 'must':

   In the event that an IP address appears in the "ciaddr" field of a
|  DHCPLEASEQUERY message, then that IP address MUST be set in the
|  "ciaddr" field of any reply returned.

|  If that IP address is one managed by the DHCP server, then it MUST
|  reply with a DHCPRELEASEACTIVE or DHCPLEASEUNASSIGNED message.

   If the IP address is not managed by the DHCP server, then a
|  DHCPLEASEUNKNOWN message MUST be returned.

Please comment on which alternative you prefer.

I propose that you submit an Author's Errata Note for RFC 4388
based on the material presented above (this would save several
additional email exchanges).  But if you like, I can also prepare
a detailed Errata Note on your advice and consent.  In any case,
issue (2) will need to be expanded properly, and for issue (3),
one of the proposals has to be selected.

Best regards,
  Alfred Hönes.

-- 

+------------------------+--------------------------------------------+
| TR-Sys Alfred Hoenes   |  Alfred Hoenes   Dipl.-Math., Dipl.-Phys.  |
| Gerlinger Strasse 12   |  Phone: (+49)7156/9635-0, Fax: -18         |
| D-71254  Ditzingen     |  E-Mail:  [email-masked]                     |
+------------------------+--------------------------------------------+